 
#ifndef __SIMPLEX__
#define __SIMPLEX__

#include "MathMatrix.h"
#include "StringHash.h"
#include "StringArray.h"


class Simplex
   {
   public:
	   Simplex(int row, int col);
	   ~Simplex();

      //bool FitLogisticModel(Matrix & X, Vector & y); // return false if not converging
	  //double GetDeviance(Matrix & X, Vector & y);

      //Vector B; // coefficient vector
	  //Matrix covB; // coefficient covariance matrix

      double ** xp;
      double *y;

	  int rowdim;
	  int coldim;
	  int count;
       

      double llk(double * beta, int p);
	  double * alloc_vector(int cols);
	  void free_vector(double * vector, int cols);
	  double ** alloc_matrix(int rows, int cols);
	  void free_matrix(double ** matrix, int rows, int cols);
	  double ** make_simplex(double * point, int dim);
	  void evaluate_simplex(double ** simplex, int dim, double * fx, double (*func)(double *, int));
	  void simplex_extremes(double *fx, int dim, int & ihi, int & ilo, int & inhi);
	  void simplex_bearings (double ** simplex, int dim, double * midpoint, double * line, int ihi);
      int update_simplex(double * point, int dim, double & fmax, double * midpoint,
				   double * line, double scale, double (*func)(double *, int));
      void contract_simplex(double ** simplex, int dim, double * fx, 
					  int ilo, double (*func)(double *, int));
      int check_tol(double fmax, double fmin, double ftol);
	  double amoeba(double * point, int dim, int rowdim,double (*func)(double *, int), double tol);
   };

#endif


